<template>
    <div v-if="currentUser.role" class="flex justify-end p-2">
  <Link href="/roster/shift/create" class="font-medium text-lime-500 hover:text-lime-600">
    <button class="btn bg-blue-700 text-white text-sm md:text-base py-2 md:py-3 px-4 md:px-6 font-medium rounded-lg hover:bg-blue-800 focus:outline-none focus:ring-2 focus:ring-blue-500">
      Create Shift
    </button>
  </Link>
</div>
    <div class="relative shadow-md sm:rounded-lg w-[90vw] md:w-full">
        <!-- <div v-if="currentUser.role" class="absolute md:-right-5 md:-top-5 -right-4 -top-4">
            <Link href="" class="font-medium text-lime-500 hover:text-lime-600">
            <Icon icon="fa-solid fa-circle-plus" class="text-3xl md:text-4xl"></Icon>
            </Link>
        </div> -->
        <div class="overflow-auto">
            <table class="w-full table-fixed text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400">
                <thead class="text-xs text-gray-700 uppercase bg-white dark:bg-gray-700 dark:text-gray-400">
                    <tr class="bg-gray-200 text-black">
                        <th scope="col" class="p-4 w-16" v-if="currentUser.role">
                            
                        </th>
                        <th scope="col" class="w-60 p-4 md:w-auto">Shift Name</th>
                        <th scope="col" class="w-60 md:w-auto">Start Time</th>
                        <th scope="col" class="w-60 md:w-auto">End Time</th>
                        <th scope="col" class="w-40 md:w-auto">Action</th>
                    </tr>
                </thead>
                <tbody>
                    <!-- Table rows -->
                    <tr class="bg-white dark:border-light-700 hover:bg-light-50 dark:hover:bg-orange-200"
                        v-for="shift in shifts.data">
                        <td class="mb-5 p-4" v-if="currentUser.role">
                            
                        </td>
                        <td class="mb-5 p-4 dark:text-black">
                            {{ shift.name }}
                        </td>
                        <td class="mb-5 dark:text-black">
                            {{ shift.start_time }}
                        </td>
                        <td class="mb-5 dark:text-black">
                            {{ shift.end_time }}
                        </td>
                        <td class="mb-5 flex items-center mt-5">
                            <Link v-if="currentUser.role" :href="`/roster/shift/${shift.id}/edit`"
                                class="font-medium dark:text-green-500 hover:underline">
                            <Icon icon="fa-solid fa-pen-to-square" class="text-2xl"></Icon>
                            </Link>
                        </td>
                    </tr>
                </tbody>
            </table>
            
        </div>
        
    </div>

    <!-- Dropdown menu -->
    <div id="dropdown-table"
        class="z-10 hidden bg-white divide-y divide-gray-100 shadow-md border border-gray-300 w-44 dark:bg-gray-700">
        <ul class="py-2 text-sm text-gray-700 dark:text-gray-200" aria-labelledby="dropdownDefaultButton">
            <li>
                <button
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 dark:hover:bg-gray-600 dark:hover:text-white"
                    @click="
                        selectionForm.selected = shifts.data.map(
                            (shift) => shift.id
                        )
                        ">
                    Select All
                </button>
            </li>
            <li>
                <button :disabled="selectionForm.selected.length === 0"
                    class="w-full text-start block px-4 py-2 hover:bg-gray-100 disabled:opacity-50 dark:hover:bg-gray-600 dark:hover:text-white"
                    @click="selectionForm.selected = []">
                    Deselect All
                </button>
            </li>
            <li>
                <button :disabled="selectionForm.selected.length === 0" @click="deleteShift"
                    class="w-full text-start block px-4 py-2 hover:bg-red-100 disabled:opacity-50 disabled:hover:bg-white dark:hover:bg-gray-600 dark:hover:text-white text-red-500">
                    Delete
                    <span v-if="selectionForm.selected.length">({{ selectionForm.selected.length }})</span>
                </button>
            </li>
        </ul>
    </div>

    <Pagination :data="shifts"></Pagination>
</template>
<script setup>
import { computed, onMounted } from "vue";
import { Link, useForm, usePage } from "@inertiajs/vue3";
import Pagination from "@/Components/Pagination.vue";
import { initDropdowns } from "flowbite";

const page = usePage();
const currentUser = computed(() => page.props.currentUser)

const props = defineProps({
    shifts: Object,
});

onMounted(() => {
    initDropdowns();
});

//selection
const selectionForm = useForm({
    selected: [],
});

function deleteShift() {
    if (confirm("Are you sure to delete?")) {
        selectionForm.delete("/roster/shift", {
            preserveScroll: true,
            preserveState: false,
        });
    }
}
</script>
